trace <- function(factor){
# x range: (pA, pA+550)
range = 550
i = seq(1, range, 1)

# parameter values
x0 = 400

lam_y = 40
lam_z = 2000
ty = 1/4
tz = 1
pcut = 0.96
color="darkgreen"

if(factor=="Rat1") {
   lam_y=600
   color="orange"
}
if(factor=="Pcf11") {
   pcut=0.2
   color="red"
}
if(factor=="Rai1") {
   pcut=0.92
   lam_y=80
   color="cyan"
}
if(factor=="Spt5") {
   pcut=0.88
   color="blue"
}

# constant value up to pA
x = rep(x0,range+1)

# formulas for the two components of the traces (after pA)
y = x0*ty*pcut*exp(-i/lam_y)
z = x0*tz*(1-pcut)*exp(-i/lam_z)

p = c(x, y+z)

# plotting
if (factor=="wt") {
    plot(c(i-range-1,0,i), log2(p), ty="l", ylim=c(3,9), lwd=3, xlab="pA",ylab="log2(coverage)",col=color)
} else {
    lines(c(i-range-1,0,i), log2(p),lwd=3, lty=3, col=color)
}
return;
}

# plot all traces
png(filename = "termination.png", width = 480, height = 480)
trace("wt")
trace("Rat1")
trace("Rai1")
trace("Pcf11")
trace("Spt5")
dev.off()
